---
title: "Vecteurs de caractères"
weight: 12
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<div id="création-rapide" class="section level3">
<h3>Création rapide</h3>
<p>Vecteur des lettres, des mois, …</p>
<pre class="r"><code>x=letters
month.name</code></pre>
<pre><code>##  [1] &quot;January&quot;   &quot;February&quot;  &quot;March&quot;     &quot;April&quot;     &quot;May&quot;       &quot;June&quot;     
##  [7] &quot;July&quot;      &quot;August&quot;    &quot;September&quot; &quot;October&quot;   &quot;November&quot;  &quot;December&quot;</code></pre>
<pre class="r"><code>state.abb</code></pre>
<pre><code>##  [1] &quot;AL&quot; &quot;AK&quot; &quot;AZ&quot; &quot;AR&quot; &quot;CA&quot; &quot;CO&quot; &quot;CT&quot; &quot;DE&quot; &quot;FL&quot; &quot;GA&quot; &quot;HI&quot; &quot;ID&quot; &quot;IL&quot; &quot;IN&quot; &quot;IA&quot;
## [16] &quot;KS&quot; &quot;KY&quot; &quot;LA&quot; &quot;ME&quot; &quot;MD&quot; &quot;MA&quot; &quot;MI&quot; &quot;MN&quot; &quot;MS&quot; &quot;MO&quot; &quot;MT&quot; &quot;NE&quot; &quot;NV&quot; &quot;NH&quot; &quot;NJ&quot;
## [31] &quot;NM&quot; &quot;NY&quot; &quot;NC&quot; &quot;ND&quot; &quot;OH&quot; &quot;OK&quot; &quot;OR&quot; &quot;PA&quot; &quot;RI&quot; &quot;SC&quot; &quot;SD&quot; &quot;TN&quot; &quot;TX&quot; &quot;UT&quot; &quot;VT&quot;
## [46] &quot;VA&quot; &quot;WA&quot; &quot;WV&quot; &quot;WI&quot; &quot;WY&quot;</code></pre>
</div>
<div id="fonctions" class="section level3">
<h3>Fonctions</h3>
<ul>
<li><p>Les fonctions qui s’appliquent à une chaîne de caractère s’appliquent aussi à un vecteur</p>
<ul>
<li>Longueur</li>
</ul></li>
</ul>
<pre class="r"><code>nchar(month.name)</code></pre>
<pre><code>##  [1] 7 8 5 5 3 4 4 6 9 7 8 8</code></pre>
<pre class="r"><code>stringr::str_length(month.name)</code></pre>
<pre><code>##  [1] 7 8 5 5 3 4 4 6 9 7 8 8</code></pre>
<ul>
<li>Concaténation</li>
</ul>
<pre class="r"><code>paste(letters,letters)</code></pre>
<pre><code>##  [1] &quot;a a&quot; &quot;b b&quot; &quot;c c&quot; &quot;d d&quot; &quot;e e&quot; &quot;f f&quot; &quot;g g&quot; &quot;h h&quot; &quot;i i&quot; &quot;j j&quot; &quot;k k&quot; &quot;l l&quot;
## [13] &quot;m m&quot; &quot;n n&quot; &quot;o o&quot; &quot;p p&quot; &quot;q q&quot; &quot;r r&quot; &quot;s s&quot; &quot;t t&quot; &quot;u u&quot; &quot;v v&quot; &quot;w w&quot; &quot;x x&quot;
## [25] &quot;y y&quot; &quot;z z&quot;</code></pre>
<pre class="r"><code>paste(letters,letters,sep=&quot;-&quot;,collapse=&quot;|&quot;)</code></pre>
<pre><code>## [1] &quot;a-a|b-b|c-c|d-d|e-e|f-f|g-g|h-h|i-i|j-j|k-k|l-l|m-m|n-n|o-o|p-p|q-q|r-r|s-s|t-t|u-u|v-v|w-w|x-x|y-y|z-z&quot;</code></pre>
<ul>
<li>Extraction</li>
</ul>
<pre class="r"><code>substr(month.name,1,3)</code></pre>
<pre><code>##  [1] &quot;Jan&quot; &quot;Feb&quot; &quot;Mar&quot; &quot;Apr&quot; &quot;May&quot; &quot;Jun&quot; &quot;Jul&quot; &quot;Aug&quot; &quot;Sep&quot; &quot;Oct&quot; &quot;Nov&quot; &quot;Dec&quot;</code></pre>
<pre class="r"><code>stringr::str_sub(month.name,1,3)</code></pre>
<pre><code>##  [1] &quot;Jan&quot; &quot;Feb&quot; &quot;Mar&quot; &quot;Apr&quot; &quot;May&quot; &quot;Jun&quot; &quot;Jul&quot; &quot;Aug&quot; &quot;Sep&quot; &quot;Oct&quot; &quot;Nov&quot; &quot;Dec&quot;</code></pre>
<ul>
<li>Recherche</li>
</ul>
<pre class="r"><code>grep(&quot;r&quot;,month.name,value=T)</code></pre>
<pre><code>## [1] &quot;January&quot;   &quot;February&quot;  &quot;March&quot;     &quot;April&quot;     &quot;September&quot; &quot;October&quot;  
## [7] &quot;November&quot;  &quot;December&quot;</code></pre>
<pre class="r"><code>grep(&quot;r&quot;,month.name)</code></pre>
<pre><code>## [1]  1  2  3  4  9 10 11 12</code></pre>
<pre class="r"><code>stringr::str_detect(month.name,&quot;r&quot;)</code></pre>
<pre><code>##  [1]  TRUE  TRUE  TRUE  TRUE FALSE FALSE FALSE FALSE  TRUE  TRUE  TRUE  TRUE</code></pre>
<pre class="r"><code>stringr::str_locate(month.name,&quot;r&quot;)</code></pre>
<pre><code>##       start end
##  [1,]     6   6
##  [2,]     4   4
##  [3,]     3   3
##  [4,]     3   3
##  [5,]    NA  NA
##  [6,]    NA  NA
##  [7,]    NA  NA
##  [8,]    NA  NA
##  [9,]     9   9
## [10,]     7   7
## [11,]     8   8
## [12,]     8   8</code></pre>
<ul>
<li>Remplacement</li>
</ul>
<pre class="r"><code>gsub(pattern = &quot;r&quot;,replacement=&quot;RRR&quot;,month.name)</code></pre>
<pre><code>##  [1] &quot;JanuaRRRy&quot;    &quot;FebRRRuaRRRy&quot; &quot;MaRRRch&quot;      &quot;ApRRRil&quot;      &quot;May&quot;         
##  [6] &quot;June&quot;         &quot;July&quot;         &quot;August&quot;       &quot;SeptembeRRR&quot;  &quot;OctobeRRR&quot;   
## [11] &quot;NovembeRRR&quot;   &quot;DecembeRRR&quot;</code></pre>
<pre class="r"><code>stringr::str_replace(string = month.name,pattern = &quot;r&quot;,replacement = &quot;RRR&quot;)</code></pre>
<pre><code>##  [1] &quot;JanuaRRRy&quot;   &quot;FebRRRuary&quot;  &quot;MaRRRch&quot;     &quot;ApRRRil&quot;     &quot;May&quot;        
##  [6] &quot;June&quot;        &quot;July&quot;        &quot;August&quot;      &quot;SeptembeRRR&quot; &quot;OctobeRRR&quot;  
## [11] &quot;NovembeRRR&quot;  &quot;DecembeRRR&quot;</code></pre>
<ul>
<li>Enlever les espaces</li>
</ul>
<pre class="r"><code>stringr::str_trim(&quot; aaa &quot;,side=&quot;right&quot;)</code></pre>
<pre><code>## [1] &quot; aaa&quot;</code></pre>
<pre class="r"><code>stringr::str_trim(&quot; aaa &quot;,side=&quot;left&quot;)</code></pre>
<pre><code>## [1] &quot;aaa &quot;</code></pre>
<ul>
<li>mettre en majuscule, en minuscule</li>
</ul>
<pre class="r"><code>toupper(&quot;Pieusse&quot;)</code></pre>
<pre><code>## [1] &quot;PIEUSSE&quot;</code></pre>
<pre class="r"><code>tolower(&quot;Paris&quot;)</code></pre>
<pre><code>## [1] &quot;paris&quot;</code></pre>
<pre class="r"><code>stringr::str_to_lower(&quot;paris&quot;)</code></pre>
<pre><code>## [1] &quot;paris&quot;</code></pre>
<pre class="r"><code>stringr::str_to_upper(&quot;Pieusse&quot;)</code></pre>
<pre><code>## [1] &quot;PIEUSSE&quot;</code></pre>
<ul>
<li>Trier</li>
</ul>
<pre class="r"><code>sort(month.name)</code></pre>
<pre><code>##  [1] &quot;April&quot;     &quot;August&quot;    &quot;December&quot;  &quot;February&quot;  &quot;January&quot;   &quot;July&quot;     
##  [7] &quot;June&quot;      &quot;March&quot;     &quot;May&quot;       &quot;November&quot;  &quot;October&quot;   &quot;September&quot;</code></pre>
<pre class="r"><code>rank(month.name)</code></pre>
<pre><code>##  [1]  5  4  8  1  9  7  6  2 12 11 10  3</code></pre>
<pre class="r"><code>order(month.name)</code></pre>
<pre><code>##  [1]  4  8 12  2  1  7  6  3  5 11 10  9</code></pre>
<ul>
<li>Découper</li>
</ul>
<pre class="r"><code>strsplit(&quot;Las que passoun tournoun pas mai&quot;,split=&quot; &quot;)</code></pre>
<pre><code>## [[1]]
## [1] &quot;Las&quot;      &quot;que&quot;      &quot;passoun&quot;  &quot;tournoun&quot; &quot;pas&quot;      &quot;mai&quot;</code></pre>
<pre class="r"><code>stringr::str_split(&quot;Las que passoun tournoun pas mai&quot;,pattern = &quot; &quot;)</code></pre>
<pre><code>## [[1]]
## [1] &quot;Las&quot;      &quot;que&quot;      &quot;passoun&quot;  &quot;tournoun&quot; &quot;pas&quot;      &quot;mai&quot;</code></pre>
</div>
